searchNodes=[{"doc":"","ref":"DistLimiter.html","title":"DistLimiter","type":"module"},{"doc":"Consume a count of resources if available.If succeeds, {:ok, remaining_count}.If falied, {:error, :overflow}. iex&gt; DistLimiter.consume({:ip, &quot;a.b.c.d&quot;, :password_challenge}, {60000, 1}, 1) {:ok, 0} iex&gt; DistLimiter.consume({:ip, &quot;a.b.c.d&quot;, :password_challenge}, {60000, 1}, 1) {:error, :overflow}","ref":"DistLimiter.html#consume/3","title":"DistLimiter.consume/3","type":"function"},{"doc":"Get remaining count of the given resource. iex&gt; DistLimiter.get_remaining({:ip, &quot;a.b.c.d&quot;, :password_challenge}, {60000, 1}) 1 iex&gt; DistLimiter.consume({:ip, &quot;a.b.c.d&quot;, :password_challenge}, {60000, 1}, 1) {:ok, 0} iex&gt; DistLimiter.get_remaining({:ip, &quot;a.b.c.d&quot;, :password_challenge}, {60000, 1}) 0","ref":"DistLimiter.html#get_remaining/2","title":"DistLimiter.get_remaining/2","type":"function"},{"doc":"DistLimiterDistributed rate limiter.","ref":"readme.html","title":"DistLimiter","type":"extras"},{"doc":"DistributedBuilt on top of pg, nodes which are interested in the same resource automatically form a process group. They record local consume timestamps and exchange those records with other nodes when being asked to consume.Garbage collectionMember processes automatically stop when window milliseconds elapsed after last consume on the node.Sliding window algorithmdist_limiter implemented sliding window algorithm.","ref":"readme.html#features","title":"DistLimiter - Features","type":"extras"},{"doc":"Let's say we want to limit password challenge from IP &quot;a.b.c.d&quot; to at most 3 times a hour.iex(1)&gt; resource = {:ip, &quot;a.b.c.d&quot;, :challenge_password} {:ip, &quot;a.b.c.d&quot;, :challenge_password} iex(2)&gt; limit = {3600 * 1000, 3} {3600000, 3} iex(3)&gt; DistLimiter.get_remaining(resource, limit) 3 iex(4)&gt; DistLimiter.consume(resource, limit, 1) {:ok, 2} iex(5)&gt; DistLimiter.consume(resource, limit, 1) {:ok, 1} iex(6)&gt; DistLimiter.consume(resource, limit, 1) {:ok, 0} iex(7)&gt; DistLimiter.consume(resource, limit, 1) {:error, :overflow}","ref":"readme.html#usage","title":"DistLimiter - Usage","type":"extras"},{"doc":"Add dist_limiter to your list of dependencies in mix.exs:def deps do [ {:dist_limiter, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"DistLimiter - Installation","type":"extras"}]